'\"
'\" Generated from file 'druma\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2018,2019 Stuart Cassoff <stwo@users\&.sourceforge\&.net>
'\"
.TH "druma" n 0\&.2 druma "DruMa"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
druma \- Teach an AitCS new moves\&.
.SH SYNOPSIS
package require \fBTcl  8\&.6\fR
.sp
package require \fBdruma  ?0\&.2?\fR
.sp
namespace import ::druma::DruMa
.sp
\fBDruMa new\fR \fIaname\fR ?\fIcreateAitCS\fR? ?\fI-fields fields\fR? ?\fI-bools bools\fR? ?\fI-listFile listFile\fR?
.sp
\fBDruMa_Basic new\fR \fIaname\fR ?\fIcreateAitCS\fR?
.sp
\fBaname:\fR ?\fImethod ?\fIarg\&.\&.\&.\fR?\fR?
.sp
\fBaname---\fR
.sp
\fBaname: fields\fR ?\fIfields\fR?
.sp
\fBaname: bools\fR ?\fIbools\fR?
.sp
\fBaname: ints\fR ?\fIints\fR?
.sp
\fBaname: floats\fR ?\fIfloats\fR?
.sp
\fBaname: colors\fR ?\fIcolors\fR?
.sp
\fBaname: listFile\fR ?\fIlistFile\fR?
.sp
\fBaname: name\fR
.sp
\fBaname: aitcs\fR
.sp
\fBaname: load\fR ?\fIlistFile\fR?
.sp
\fBaname: save\fR ?\fIlistFile\fR?
.sp
\fBaname: validate\fR
.sp
\fBaname: validateBools\fR
.sp
\fBaname: validateInts\fR
.sp
\fBaname: validateFloats\fR
.sp
\fBaname: validateColors\fR
.sp
\fBaname: makeBool\fR \fIbool\fR
.sp
\fBaname: yesnoBool\fR \fIbool\fR
.sp
namespace import ::druma::makeBool
.sp
namespace import ::druma::yesnoBool
.sp
\fBmakeBool\fR \fIbool\fR
.sp
\fByesnoBool\fR \fIbool\fR
.sp
.BE
.SH DESCRIPTION
A DruMa is an object that augments an AitCS
(Array in the Command's Shadow) by being an object
that doesn't "wrap" the AitCS but "links" with it\&.
.PP
New functionality includes field definition, validation, loading and saving\&.
.PP
A DruMa may be used where a program would normally use an AitCS\&.
They work alongside each other, not in or over\&.
The AitCS is used normally, without interference by the DruMa\&.
.PP
The class DruMa is a subclass of the class DruMa_Basic\&.
The class DruMa provides field definition, validation, loading and saving\&.
The class DruMa_Basic provides the basic creation and linking\&.
The class DruMa_Basic is not exported\&.
.PP
The added accessor alias "aname:" enables a gateway to unlimited functionality\&.
Simply subclass DruMa or DruMa_Basic and add new methods, variables, etc\&.
.PP
In this document, the term, method or argument "aname" or "aname<something>"
refers to the AitCS name supplied when the DruMa is created (ex: "name!")\&.
Methods on the object can be called normally,
but they are shown in this document as being accessed via the "aname:" alias\&.
.SH "INSTANCE CREATION"
.TP
\fBDruMa new\fR \fIaname\fR ?\fIcreateAitCS\fR? ?\fI-fields fields\fR? ?\fI-bools bools\fR? ?\fI-listFile listFile\fR?
Creates a DruMa, optionally creates an AitCS named \fIaname\fR, links them together\&.
Returns the newly-created DruMa\&.
.sp
The \fIcreateAitCS\fR argument is passed to DruMa_Basic's \fBnew\fR method\&.
.TP
\fBDruMa_Basic new\fR \fIaname\fR ?\fIcreateAitCS\fR?
Creates a DruMa_Basic object, optionally creates an AitCS named \fIaname\fR, links them together\&.
Returns the newly-created DruMa_Basic object\&.
.sp
If \fIcreateAitCS\fR is true (default) then a new AitCS is created, with
the command namespace set to the caller's namespace, and
the variable namespace set to the DruMa_Basic's namespace\&.
If \fIcreateAitCS\fR is false then it is assumed that the AitCS named by \fIaname\fR already exists\&.
.sp
The "aname---" destructor alias is changed to call
the DruMa's destructor method\&.
Destroying the DruMa or invoking the destructor alias
will destroy both the DruMa and the AitCS\&.
.sp
The "aname:" alias is added, providing a gateway to the DruMa/DruMa_Basic (or other) object\&.
.sp
The added and changed alias are the only "hard" link between the AitCS and the DruMa\&.
.sp
There is no need to save the DruMa in a variable
since it can be accessed via the AitCS\&.
.PP
.SH "AITCS COMMANDS"
Added or modified AitCS commands\&.
.TP
\fBaname:\fR ?\fImethod ?\fIarg\&.\&.\&.\fR?\fR?
Added command\&.
Calls a method on the DruMa linked with the AitCS, passing any args\&.
Returns the value returned from the method
or the DruMa if called without a method\&.
Nickname: Object accessor\&.
.TP
\fBaname---\fR
Modified command\&.
Calls the DruMa's destructor\&.
The DruMa's destructor will call the AitCS's destructor\&.
Returns an empty string\&.
Nickname: Destroy\&.
.PP
.SH "DRUMA ACCESSORS"
DruMa accessors get or set the value of DruMa variables\&.
Read-only variables take no argument\&.
.TP
\fBaname: fields\fR ?\fIfields\fR?
.TP
\fBaname: bools\fR ?\fIbools\fR?
.TP
\fBaname: ints\fR ?\fIints\fR?
.TP
\fBaname: floats\fR ?\fIfloats\fR?
.TP
\fBaname: colors\fR ?\fIcolors\fR?
.TP
\fBaname: listFile\fR ?\fIlistFile\fR?
.TP
\fBaname: name\fR
Returns the name of the AitCS linked with the DruMa\&.
.TP
\fBaname: aitcs\fR
Returns the AitCS linked with the DruMa\&.
.PP
.SH "DRUMA METHODS"
.TP
\fBaname: load\fR ?\fIlistFile\fR?
Loads the data from the DruMa's listFile into the AitCS then validates\&.
Filter input using fields\&.
If \fIlistFile\fR is supplied
then the DruMa's listFile will be set to \fIlistFile\fR
before loading\&.
.TP
\fBaname: save\fR ?\fIlistFile\fR?
Validates then saves the data from the AitCS to the DruMa's listFile\&.
Filter output using fields\&.
If \fIlistFile\fR is supplied
then the DruMa's listFile will be set to \fIlistFile\fR
before saving\&.
.TP
\fBaname: validate\fR
Validates all fields\&.
.TP
\fBaname: validateBools\fR
Validates all bool fields\&.
.TP
\fBaname: validateInts\fR
Validates all int fields\&.
.TP
\fBaname: validateFloats\fR
Validates all float fields\&.
.TP
\fBaname: validateColors\fR
Validates all color fields\&.
.TP
\fBaname: makeBool\fR \fIbool\fR
See the \fBmakeBool\fR command\&.
.TP
\fBaname: yesnoBool\fR \fIbool\fR
See the \fByesnoBool\fR command\&.
.PP
.SH COMMANDS
.TP
\fBmakeBool\fR \fIbool\fR
Returns
1 if \fIbool\fR is true
or
0 if \fIbool\fR is false or not a bool\&.
.TP
\fByesnoBool\fR \fIbool\fR
Returns
"yes" if \fIbool\fR is true
or
"no" if \fIbool\fR is false\&.
.PP
.SH "LIST FILE"
A list file is a text file where each line is
a two-element Tcl list as a name-value pair\&.
When loading, lines beginning with "#" and blank lines are ignored\&.
.SH EXAMPLES
This example code exists in the file examples/breakfast\&.tcl\&.
.CS



	# Start your morning with DruMa!

	package require druma
	namespace import ::druma::DruMa


	# Create a DruMa, and by consequence, an AitCS\&.
	# Supply fields and bools at creation time\&.

	DruMa new breakfast \\
		-fields {toast jam cereal coffee togo} \\
		-bools {cereal togo}


	# Setup fields\&. Note the bad bool!

	breakfast {*}{
		toast   2
		jam     durian
		coffee  "many cups of delicious"
		cereal  "I'm the bad bool!"
	}


	# Call with "G" to invite Godzilla\&.

	breakfast togo [expr {[llength $::argv] == 1 && [lindex $::argv 0] eq "G"}]


	# Call the DruMa validate method to correct any bad fields (currently only bools)\&.

	breakfast: validate


	# Setup other breakfast elements that DruMa doesn't care about\&.

	breakfast time    eventually
	breakfast guests  [list Bob Connie Laika Reagan]
	breakfast nguests [llength [breakfast guests]]


	# Godzilla tends to destroy the breakfast nook\&. Sorry\&.

	if {[breakfast togo]} { # Bad bool field has been corrected!
		breakfast+ guests Godzilla
		breakfast+= nguests
	}


	# Another bad bool!

	breakfast cereal muesli


	# Save\&. Bad fields will be corrected\&. The listFile will be set\&.

	breakfast: save breakfast\&.txt


	# Mess up breakfast\&.

	breakfast toast  -100
	breakfast coffee decaf


	# When do we eat?

	breakfast time morning


	# Load\&. Bad fields will be corrected\&. The listFile was set when breakfast was saved\&.

	breakfast: load


	# Adjust for certain guests who may eat more than others\&. Just sayin'\&.

	if {"Godzilla" in [breakfast guests]} {
		breakfast   cereal 1
		breakfast+= toast 2
	}


	# We're out of durian jam\&. Hope strawberry's ok\&.

	breakfast jam strawberry


	# Let's eat!

	puts "[breakfast nguests] are having breakfast in the\\
		[expr {[breakfast togo] ? "park adjacent" : "breakfast nook"}]!"

	puts "This [breakfast time], our guests are\\
		[join [lrange [breakfast guests] 0 end-1] ", "],\\
		and [lindex [breakfast guests] end]\&."

	puts "They'll be having\\
		[breakfast toast] slices of toast with\\
		[breakfast jam] jam,[expr {[breakfast cereal] ? " cereal," : ""}]\\
		and [breakfast coffee] coffee\&."


	# Clean up / Check cleanup went ok

	set obj [breakfast:]
	set arr [breakfast&]
	set cmd [breakfast&&]

	set ok 0

	incr ok [info object isa object $obj]
	incr ok [array exists $arr]
	incr ok [expr {[llength [info commands $cmd]] == 1}]

	if {$ok != 3} { error "Breakfast cleanup: where is breakfast?" }

	breakfast---

	incr ok [info object isa object $obj]
	incr ok [array exists $arr]
	incr ok [expr {[llength [info commands $cmd]] == 1}]

	if {$ok != 3} { error "Breakfast cleanup: leftovers" }

.CE
.PP
Running the example code\&.
.CS


	$ \&./breakfast\&.tcl

	4 are having breakfast in the breakfast nook!
	This morning, our guests are Bob, Connie, Laika, and Reagan\&.
	They'll be having 2 slices of toast with strawberry jam, and many cups of delicious coffee\&.


	$ \&./breakfast\&.tcl G

	5 are having breakfast in the park adjacent!
	This morning, our guests are Bob, Connie, Laika, Reagan, and Godzilla\&.
	They'll be having 4 slices of toast with strawberry jam, cereal, and many cups of delicious coffee\&.


	$ cat breakfast\&.txt

	cereal  no
	coffee  {many cups of delicious}
	jam     durian
	toast   2
	togo    yes


.CE
In order to get the example to format properly,
lines normally terminated with "\\" are terminated here with "\\ "\&.
When copying the example code, adjust for this\&.
.SH "SEE ALSO"
aitcs(n)
.SH KEYWORDS
alias, array, command, drunken, eagle, master, namespace, object, shadow, snake
.SH CATEGORY
Programming tools
.SH COPYRIGHT
.nf
Copyright (c) 2018,2019 Stuart Cassoff <stwo@users\&.sourceforge\&.net>

.fi